from cStringIO import StringIO
import json
import urlparse


def handler(request):
    data = {
        "high": ["high", ["highlight"]],
        "foo": ["foo", ["food", "foot", "fool", "foobar", "foo five"]],
        "QML": ["QML", ["qt qml", "qml documentation", "qml rocks"]]
    }
    query = urlparse.parse_qs(request.path.split('?', 1)[1])["q"][0]
    try:
        suggestions = data[query]
    except KeyError:
        suggestions = []
    html = StringIO()
    html.write(json.dumps(suggestions).encode())
    request.send_response(200)
    request.send_header("Content-Type", "application/json")
    request.send_header("Content-Length", html.tell())
    request.end_headers()
    request.wfile.write(html.getvalue())
