from cStringIO import StringIO
import urlparse

HTML = """<html>
  <body>
    <script type="text/javascript">
      navigator.webkitGetUserMedia(
        {{ audio: {}, video: {} }},
        function() {{ location.href = '/media-allowed.html'; }},
        function() {{ location.href = '/media-denied.html'; }}
      );
    </script>
  </body>
</html>"""

def handler(request):
    query = urlparse.parse_qs(request.path.split('?', 1)[1])
    audio = "audio" in query and query["audio"][0] == "true"
    video = "video" in query and query["video"][0] == "true"
    html = StringIO()
    html.write(HTML.format(str(audio).lower(), str(video).lower()))
    request.send_response(200)
    request.send_header("Content-Length", html.tell())
    request.end_headers()
    request.wfile.write(html.getvalue())
