# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
#
# Copyright 2016 Canonical
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

import os
import os.path
import signal
import sys

thisdir = os.path.dirname(__file__)
sys.path.insert(0, os.path.join(thisdir, os.pardir))
from httpserver import TestHTTPServer


if __name__ == '__main__':
    signal.signal(signal.SIGTERM, lambda signal, frame: sys.exit(0))
    server = TestHTTPServer(0, thisdir)
    sys.stdout.write("PORT:{}".format(str(server.server_port)))
    sys.stdout.flush()
    server.serve_forever()
